﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {        
            InitializeComponent();
            grid.CurrentCellActivated += grid_CurrentCellActivated;        
        }

        private void grid_CurrentCellActivated(object sender, CurrentCellActivatedEventArgs args)
        {
            //get the current cell
            var currentcell = grid.SelectionController.CurrentCellManager.CurrentCell.ColumnElement;

            // search the button using Visual tree
            Button button = GetVisualChild<Button>(currentcell);

            //current cell row data
            var rowdata = (Student)currentcell.DataContext;

            //based on the data button visibilty has been decided
            if (rowdata.Age != 12 && button != null)
                button.Visibility = Visibility.Visible;
        }

        private T GetVisualChild<T>(DependencyObject parent) where T : Visual
        {
            T child = default(T);
            int numVisuals = VisualTreeHelper.GetChildrenCount(parent);
            for (int i = 0; i < numVisuals; i++)
            {
                Visual v = (Visual)VisualTreeHelper.GetChild(parent, i);
                child = v as T;
                if (child == null)
                {
                    child = GetVisualChild<T>(v);
                }
                if (child != null && child.GetType() == typeof(Button))
                {
                    break;
                }
            }
            return child;
        }
    }
   
}
